#!/usr/bin/perl

#Copyright (C) 2006-2008 Keio University
#(Kris Popendorf) <comp@bio.keio.ac.jp> (2006)
#
#This file is part of Murasaki.
#
#Murasaki is free software: you can redistribute it and/or modify
#it under the terms of the GNU General Public License as published by
#the Free Software Foundation, either version 3 of the License, or
#(at your option) any later version.
#
#Murasaki is distributed in the hope that it will be useful,
#but WITHOUT ANY WARRANTY; without even the implied warranty of
#MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#GNU General Public License for more details.
#
#You should have received a copy of the GNU General Public License
#along with Murasaki.  If not, see <http://www.gnu.org/licenses/>.

use File::Basename;

$mauvePath="/home/krisp/mauve/mauveAligner";
$outprefix="./output";
mkdir($outprefix);

foreach $arg (@ARGV) {
  push(@seqs,$arg);
}

foreach $seq (@seqs){
  push(@opts,"$seq","$seq.sml");
  push(@seqnames,getName($seq));
}

$output="$outprefix/".join("-",@seqnames).".mauve";
do {
  system($mauvePath,"--mums","--eliminate-inclusions","--output=$output",@opts);
  print "\nMauve done. stored to $output\n";
} unless -e $output;
$anchorout="$output.anchors";

print "Converting to custom format\n";
open(ANCHORS,">$anchorout");
open(MAUVE,$output);
until(<MAUVE>=~m/MatchCount/) {}
while($line=<MAUVE>){
  @fields=split(/\s/,$line);
  $length=@fields[0];
  print ANCHORS join(" ",map {
    my $pos=$_,$sign='+';
    $sign='-' if $pos<0;
    (abs($pos),abs($pos+$length),$sign)} @fields[1..($#seqs+1)]);
  print ANCHORS "\n";
}
close(MAUVE);
close(ANCHORS);
print "Done. Anchors stored to $anchorout\n";

sub getName {
  @ret=map {
#    m!.*?/?([^./]+)\..*?! or print "Eek. Couldn't extract name from $_\n";
# $1
    ($name,$path,$suffix) = fileparse($_,qr{\.[^.]*});
    $name
    } @_;
  return @ret if $#_;
  return $ret[0];
}
